# -*- coding: utf-8 -*-
"""separate-stripe-data

Revision ID: 88a7f795d5d8
Revises: baeb5bf63906
Create Date: 2023-12-21 22:33:08.166116

"""
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

from alembic import op

# revision identifiers, used by Alembic.
revision = "88a7f795d5d8"
down_revision = "baeb5bf63906"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "stripe_customer",
        sa.Column("id", sa.Uuid(), nullable=False),
        sa.Column("created_at", sa.DateTime(), nullable=False),
        sa.Column("personal_information_id", sa.Uuid(), nullable=False),
        sa.Column("stripe_customer_id", sa.String(length=32), nullable=False),
        sa.ForeignKeyConstraint(
            ["personal_information_id"],
            ["billing_person.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "stripe_subscription",
        sa.Column("id", sa.Uuid(), nullable=False),
        sa.Column("created_at", sa.DateTime(), nullable=False),
        sa.Column("subscription_id", sa.Uuid(), nullable=False),
        sa.Column("stripe_key", sa.String(length=32), nullable=False),
        sa.Column("stripe_subscription_id", sa.String(length=32), nullable=True),
        sa.ForeignKeyConstraint(
            ["subscription_id"],
            ["billing_subscription.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("subscription_id"),
    )
    op.add_column("billing_person", sa.Column("user_id", sa.Uuid(), nullable=False))
    op.create_foreign_key(None, "billing_person", "user", ["user_id"], ["id"])
    op.drop_column("billing_subscription", "stripe_key")
    op.drop_column("billing_subscription", "stripe_subscription_id")
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "billing_subscription",
        sa.Column("stripe_subscription_id", mysql.VARCHAR(length=32), nullable=True),
    )
    op.add_column(
        "billing_subscription",
        sa.Column("stripe_key", mysql.VARCHAR(length=32), nullable=False),
    )
    op.drop_constraint(None, "billing_person", type_="foreignkey")
    op.drop_column("billing_person", "user_id")
    op.drop_table("stripe_subscription")
    op.drop_table("stripe_customer")
    # ### end Alembic commands ###
